var Web3 = require('web3');
var BigNumber = require('big-number');
var web3 = new Web3();

var verosContract;
var verosInstance;

var coinbaseAddress;
var coinbasePassword;

var _sandbox;
var _startBlock;

/*
 * Connect to local Ethereum Node
 */
function connectToEthereumNode(ip,address,password,sandbox,completion) {
    web3.setProvider(new web3.providers.HttpProvider(ip));

    if (!sandbox) {
        sandbox = false;
    }
    _sandbox = sandbox;
    if (sandbox) {
        _startBlock = 1870609;
        verosContract = web3.eth.contract([{"constant":false,"inputs":[{"name":"_spender","type":"address"},{"name":"_value","type":"uint256"}],"name":"approve","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_from","type":"address"},{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"}],"name":"balanceOf","outputs":[{"name":"balance","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transfer","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_children","type":"address"},{"name":"_parent","type":"address"}],"name":"addChildrenAddress","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"},{"name":"_spender","type":"address"}],"name":"allowance","outputs":[{"name":"remaining","type":"uint256"}],"payable":false,"type":"function"},{"inputs":[{"name":"_genesisWalletAddress","type":"address"},{"name":"_mainWalletAddress","type":"address"},{"name":"_feeWalletAddress","type":"address"}],"type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_from","type":"address"},{"indexed":true,"name":"_to","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_owner","type":"address"},{"indexed":true,"name":"_spender","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_parent","type":"address"},{"indexed":true,"name":"_children","type":"address"}],"name":"AddChildren","type":"event"}]);
        verosInstance = verosContract.at("0x703eef9e7536b16ceb9807ef557c6ee978b6cd55");
    } else {
        verosContract = web3.eth.contract([{"constant":false,"inputs":[{"name":"_spender","type":"address"},{"name":"_value","type":"uint256"}],"name":"approve","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_availableSupply","type":"uint256"}],"name":"setAvailableSupply","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"totalSupply","outputs":[{"name":"","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_from","type":"address"},{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transferFrom","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"balances","outputs":[{"name":"","type":"uint256"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"}],"name":"balanceOf","outputs":[{"name":"balance","type":"uint256"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"availableSupply","outputs":[{"name":"","type":"uint256"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_children","type":"address"},{"name":"_parent","type":"address"}],"name":"removeChildrenAddress","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[],"name":"owner","outputs":[{"name":"","type":"address"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"childrens","outputs":[{"name":"","type":"address"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_to","type":"address"},{"name":"_value","type":"uint256"}],"name":"transfer","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":false,"inputs":[{"name":"_children","type":"address"},{"name":"_parent","type":"address"}],"name":"addChildrenAddress","outputs":[{"name":"success","type":"bool"}],"payable":false,"type":"function"},{"constant":true,"inputs":[{"name":"_owner","type":"address"},{"name":"_spender","type":"address"}],"name":"allowance","outputs":[{"name":"remaining","type":"uint256"}],"payable":false,"type":"function"},{"inputs":[{"name":"_genesisWalletAddress","type":"address"},{"name":"_mainWalletAddress","type":"address"},{"name":"_stakingWalletAddress","type":"address"},{"name":"_stakeholderWalletAddress","type":"address"},{"name":"_investorWalletAddress","type":"address"},{"name":"_feeWalletAddress","type":"address"}],"type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_from","type":"address"},{"indexed":true,"name":"_to","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Transfer","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_owner","type":"address"},{"indexed":true,"name":"_spender","type":"address"},{"indexed":false,"name":"_value","type":"uint256"}],"name":"Approval","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_parent","type":"address"},{"indexed":true,"name":"_children","type":"address"}],"name":"AddChildren","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"_parent","type":"address"},{"indexed":true,"name":"_children","type":"address"}],"name":"RemoveChildren","type":"event"}]);
        verosInstance = verosContract.at("0x6bF93bEc191169Bd09594cF5704574c9cc0DD92a");
        _startBlock = 2649220;
    }
    if (!checkAccount(address,password)) {
        return completion("Coinbase credentials not usable");
    }
    coinbaseAddress = address;
    coinbasePassword = password;

    try {
        var blockNumber = getBlockNumber();
        module.exports
        completion(null,blockNumber);
    } catch(err) {
        completion(err,null);
    }
}

function getBlockNumber() {
    return web3.eth.blockNumber;
}

function createAccount(password) {
    return web3.personal.newAccount(password);
}

function getTotalSupply() {
    return verosInstance.totalSupply.call();
}

function getAvailableSupply() {
    return verosInstance.availableSupply.call();
}

function getVerosInstance() {
    return verosInstance;
}

function getWeb3() {
    return web3;
}

function sendEther(from,password,to,amount,completion) {
    if (!checkAccount(from,password)) {
        return completion("Cannot unlock account " + from,null);
    }
    var tx = web3.eth.sendTransaction({
        from: from,
        to:to,
        value:web3.toWei(amount,'ether')
    });

    completion(null,tx);
}

/*
 * Check the credentials for the selected account
 */
function checkAccount(address,password) {
    if (address.length != 42) {
        console.log("Err: Invalid address length (" + address + ")");
        return false;
    }
    try {
        return web3.personal.unlockAccount(address.slice(2), password);
    } catch (err) {
        return false;
    }
}
/*
 * Return VEROS balance
 */
function getVerosBalance(address) {
    return balance = verosInstance.balanceOf.call(address);
}

/*
 * List all accounts
 */
function listAccounts() {
    return web3.eth.accounts;
}

/*
 * Send VEROS
 */
function transfer(fromAccount, fromAccountPassword, recipientAddress,amount,completion) {
    if (!checkAccount(fromAccount,fromAccountPassword)) {
        return completion("Cannot unlock sender account",null);
    }
    try {
        verosInstance.transfer(
            recipientAddress,
            amount, {
            from: fromAccount
        }, function (err, tx) {
            completion(err, tx);
        });
    } catch (err) {
        completion(err,null);
    }
}

function transferFrom(signerAccount, signerAccountPassword, fromAddress, toAddress, amount, completion) {
    if (!checkAccount(signerAccount,signerAccountPassword)) {
        return completion("Cannot unlock sender account",null);
    }

    try {
        verosInstance.transferFrom(
            fromAddress,
            toAddress,
            amount, {
                from: signerAccount
            }, function (err, tx) {
                completion(err, tx);
            });
    } catch (err) {
        completion(err,null);
    }

}

function addChildrenAddress(ownerAccount,ownerAccountPassword,parentAddress,childPassword,completion) {
    if (!checkAccount(ownerAccount,ownerAccountPassword)) {
        return completion("Cannot unlock sender account",null,null);
    }
    var childrenAddress = createAccount(childPassword);
    verosInstance.addChildrenAddress(childrenAddress,parentAddress,{
        from: ownerAccount
    },function(err,tx) {
        if (err) {
            completion(err,null,null)
        } else {
            completion(null,tx,childrenAddress);
        }
    });
}

function removeChildrenAddress(ownerAccount,ownerAccountPassword,parentAddress,childrenAddress,completion) {
    if (!checkAccount(ownerAccount,ownerAccountPassword)) {
        return completion("Cannot unlock sender account",null,null);
    }
    verosInstance.removeChildrenAddress(childrenAddress,parentAddress,{
        from: ownerAccount
    },function(err,tx) {
        if (err) {
            completion(err,null,null)
        } else {
            completion(null,tx,childrenAddress);
        }
    });
}

function getChildren(parentAddress,completion) {
    completion(verosInstance.childrens.call(parentAddress));
}

function getChildrenEvents(completion) {
    var addChildrenEvent = verosInstance.AddChildren(null, {fromBlock:_startBlock, toBlock: 'latest'});

    addChildrenEvent.get(function(error, events) {
        completion(error,events);
    });
}

function getTransfers(userAddress,completion) {
    if (userAddress) {
        var transferEvent = verosInstance.Transfer({_from:userAddress}, {fromBlock: _startBlock, toBlock: 'latest'});
        var outgoingTransfers = [];
        var incomingTransfers = [];
        transferEvent.get(function (error, events) {
            events.forEach(function(event,index) {
                outgoingTransfers.push(transferEventToObject(event));
            });

            var transferEvent = verosInstance.Transfer({_to:userAddress}, {fromBlock: _startBlock, toBlock: 'latest'});
            transferEvent.get(function (error, events) {
                events.forEach(function (event, index) {
                    incomingTransfers.push(transferEventToObject(event));
                });

                completion(error,  {
                    incoming:incomingTransfers,
                    outgoing:outgoingTransfers
                });
            });
        });
    } else {
        var transferEvent = verosInstance.Transfer(null, {fromBlock: _startBlock, toBlock: 'latest'});
        transferEvent.get(function (error, events) {
            var transfers = [];
            events.forEach(function(event,index) {
                transfers.push(transferEventToObject(event));
            });
            completion(error, transfers);
        });
    }
}

function transferEventToObject(transferEvent) {
    return {
        senderAddress:transferEvent.args["_from"],
        receiverAddress:transferEvent.args["_to"],
        amount:transferEvent.args["value"],
        transactionHash:transferEvent.transactionHash,
        transactionTimestamp: web3.eth.getBlock(transferEvent.blockNumber).timestamp
    }
}

module.exports = {
    // Init
    connectToEthereumNode:connectToEthereumNode,
    getBlockNumber:getBlockNumber,
    getWeb3:getWeb3,
    getVerosInstance:getVerosInstance,
    sendEther:sendEther,

    // Accounts
    createAccount:createAccount,
    checkAccount:checkAccount,
    listAccounts:listAccounts,

    // Veros
    transfer:transfer,
    transferFrom:transferFrom,
    getChildren:getChildren,
    addChildrenAddress:addChildrenAddress,
    removeChildrenAddress:removeChildrenAddress,
    getVerosBalance:getVerosBalance,

    // Events
    getTransfers:getTransfers,
    getChildrenEvents:getChildrenEvents,

    // Supply
    getTotalSupply:getTotalSupply,
    getAvailableSupply:getAvailableSupply
};